#include "QuicksortThread.hh"

#include <iostream>
using namespace std;

QuicksortThread::QuicksortThread(int bottom, 
		int top,
		std::vector<int>& array)
	: Thread(true),
	  bottom_(bottom),
	  top_(top),
	  array_(array)
{
	
}

void swap_int(int& a, int& b) {
	int tmp=a;
	a=b;
	b=tmp;
}

void QuicksortThread::run() {
	cout << "Quicksort(" << bottom_ << ", " << top_ << ")" << endl;
	if(bottom_>=top_) {
		return;
	}
	int left=bottom_-1;
	int right=top_;
	int pivot=array_[top_];

	while(left<right) {
		do {left++;} while (array_[left]<pivot);
		do {right--;} while (array_[right]>pivot);
		if(left<right) {
			swap_int(array_[left],array_[right]);
		}
	}

	int pivot_index=left;
	swap_int(array_[pivot_index],array_[top_]);
	

	QuicksortThread left_thread(bottom_,pivot_index-1,array_);
	left_thread.start();
	QuicksortThread right_thread(pivot_index+1,top_,array_);
	right_thread.start();

	left_thread.join();
	right_thread.join();
	
}
