#include "Thread.hh"
#include "Mutex.hh"
#include "ThreadError.hh"
#include "QuicksortThread.hh"

#include <iostream>
#include <fstream>
#include <vector>
#include <ctime>
using namespace std;

void static usage() {
	cerr << "quicksort <filename>" << endl;
}

void read_vector(char* filename, vector<int>& v) {
	ifstream is(filename);
	while(is) {
		int value;
		is >> value;
		if(!is) break;
		v.push_back(value);		
	}
}

int main(int argc,char* argv[]) {
	if(argc!=2) {
		usage();
		exit(1);
	}	

	vector<int> a;
	read_vector(argv[1],a);

	cout << "a={";
	for(vector<int>::iterator it=a.begin();it!=a.end();++it) {
		cout << (*it) << " ";
	}
	cout << "}" << endl;

	QuicksortThread q(0,a.size()-1,a);
	q.start();

	q.join();
	
	cout << "a={";
	for(vector<int>::iterator it=a.begin();it!=a.end();++it) {
		cout << (*it) << " ";
	}
	cout << "}" << endl;

	
	return 0;
};
